# Disable debuginfo because is make no sense for haskell staff

%define debug_package %{nil}

Name:		kaya
Version:	0.5.2
Release:	10%{?dist}
Summary:	A Statically typed, imperative programming-language

Group:		Development/Languages
License:	GPLv2+ and LGPLv2+
URL:		http://kayalang.org
Source0:	http://kayalang.org/src/%{name}-%{version}.tgz
Patch1:		kaya-0.5.2-conf.patch

# Patch from upstream
Patch2:	        kaya-0.5.2-ghc612.patch

# will be send to upstream
Patch3:		kaya-0.5.2-gc.patch
Patch4:		kaya-0.5.2-dyn.patch
Patch5:		kaya-0.5.2-codegen.patch

# fedora ghc has only been bootstrapped on the following archs:
ExclusiveArch: %{ix86} x86_64 ppc alpha sparcv9

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  libtool, autoconf, pkgconfig, ghc-devel, 
BuildRequires:	ghc >= 6.10.3, gc-devel, happy, zlib-devel, gnutls-devel
BuildRequires:  libgcrypt-devel, pcre-devel ghc-editline-devel
BuildRequires:	postgresql-devel, mysql-devel, sqlite-devel
BuildRequires:  gd-devel, SDL-devel, mesa-libGL-devel
BuildRequires:  ncurses-devel, freeglut-devel

# %if 0%{?fedora} > 12
BuildRequires: ghc-mtl-devel
# %endif

%description
Kaya is a compiled statically typed (ie, types are checked at compile time)
imperative programming language; unlike other such languages, however, types
are inferred rather than declared - there is no need for type declarations of
local variables. Kaya has "tagged union" data structures, a powerful feature 
more commonly found in functional languages such as Ocaml and Haskell.

Kaya also has built-in abstractions for web application development, making 
it easy to write a CGI program without paying too much attention to low level 
details such as state management and form handling. 

%package doc
Summary: Documentation and Samples for the Kaya Language
Group:	 Documentation
BuildArch: noarch

%description doc
This package contains the documentation for the kaya language.

Additional you may find samples for this language.

%prep
%setup -q
%patch1 -p1 -b .orig
%patch2 -p1 -b .ghc621
%patch3 -p1 -b .gc
%patch4 -p1 -b .dyn
%patch5 -p1 -b .codegen

%build
autoconf
autoreconf
CFLAGS=$(echo $RPM_OPT_FLAGS | sed -e 's/\-wp,\-D_FORTIFY_SOURCE=2//g' | \
                               sed -e 's/\-fstack\-protector//g' )
%configure

# make doesn't support _smp_flags
make # %{?_smp_mflags} 

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT libdir=%{_libdir}/kaya

pushd $RPM_BUILD_ROOT%{_bindir}
strip kayac
strip kaya-rekey
strip kayadoc2man
popd

%check
# test063 fails due to DSOImplicitLinking ( FTBFS http://bugzilla.redhat.com/555493 )
# make non-fatal for now, just so we can get a build done, but it still needs to
# be fixed properly
make test ||:

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_bindir}/kaya
%{_bindir}/kayac
%{_bindir}/kaya-rekey
%{_bindir}/kayadoc2man
%{_libdir}/kaya/
%{_mandir}/man1/*

%doc COPYING GPL2 GPL3 LGPL2.1 LGPL3

%files doc
%defattr(-,root,root,-)
%{_mandir}/man3/*
%doc examples/ docs/

%changelog
* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Feb  1 2011 Dan Horák <dan[at]danny.cz> - 0.5.2-9
- updated the supported arch list

* Wed Dec  1 2010 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-8
- Fix for ghc-7.0.1

* Wed May  5 2010 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-6
- Fix GC-API issue and ImplicitDSOLining failure (#555493)

* Mon May 03 2010 Rex Dieter <rdieter@fedoraproject.org> 0.5.3-6
- New gc release breaks kaya build (#587391)
- FIXME/TODO: ImplicitDSOLinking failure in %%check test063

* Sat Mar  6 2010 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-5
- Fix FTBFS agains ghc-6.12 (#555493)

* Wed Jul 29 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-4
- Fix wrong BR.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 22 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-2
- Bump release

* Sun Jun 28 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-1
- New upstream release

* Thu Mar  5 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.1-4
- Supporting noarch subpackages

* Tue Mar  3 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.1-3
- Fix ghc-6.10 releated issues

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 0.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Aug  4 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.1-1
- New upstream release

* Mon Jun  9 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-5
- Koji don't like -fstack-protector

* Thu Jun  5 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-4
- Fix issue to detect mysql in configure script

* Sun Jun  1 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-3
- Add default attributes for doc package files
- Fix SMP issue

* Thu May 29 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-2
- Striping executables files

* Mon May 26 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-1
- New upstream relase

* Sun May  4 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-5
- Comment special handlings
- Create sub package for documentation and samples

* Mon Apr 28 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-4
- Fix some smp issues

* Mon Apr 28 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-3
- Enable parallel building

* Sun Apr 27 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-2
- disable generating of debuginfo package
- Remove unnecessary patch

* Tue Apr 15 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-1
- New upstream release

* Thu Nov 29 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.7-4
- Generate debuginfos
- Fix an error in the kayac man page

* Wed Nov  7 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.7-3
- Fix build id issue

* Tue Oct 30 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.7-1
- New upstream release

* Tue Oct  9 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.6-2
- Fix wrong license tag.

* Tue Sep 11 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.6-1
- Initial RPM

